package me.icymint.libra.sage.core.param;

import java.sql.PreparedStatement;
import java.sql.SQLException;
import java.util.Arrays;

public class DefaultParamHandler<U extends PreparedStatement> extends
		AbstractParamHandler<Object, U> {

	@Override
	public U handle(U pps, int[] types, Object... param) throws SQLException {
		for (int i = 0; i < param.length; i++) {
			Object o = param[i];
			try {
				if (o == null)
					pps.setNull(i + 1, types[i]);
				else
					pps.setObject(i + 1, o, types[i]);
			} catch (SQLException e) {
				throw new SQLException(Arrays.toString(param), e);
			}
		}
		return pps;
	}
}
