package me.icymint.libra.sage.core.query;

import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;

/**
 * 所有的Jdbc查询类接口。 查询有三种形式：
 * <p/>
 * 1. 直接从{@link Connection}中获取元数据信息。 <br/>
 * 实现方式：直接实现本接口。
 * <p/>
 * 2. 从{@link Connection}中获取{@link ResultSet}形式的元数据信息。<br/>
 * 实现方式：扩展类{@link MetaDataQuery}
 * <p/>
 * 3. 执行SQL语句查询获取{@link ResultSet}。<br/>
 * 实现方式：{@link SqlQuery}
 * 
 * @author Daniel
 * @datetime 2012-11-9下午1:47:01
 * 
 * @param <T>
 *            返回结果。
 */
public interface SqlQuery<T> {

	/**
	 * 根据给定的{@link Connection}来进行查询。查询相关参数由本接口的实现类来输入。
	 * 
	 * @param conn
	 * @throws SQLException
	 */
	T query(Connection conn) throws SQLException;

}
