package me.icymint.libra.sage.model;

import me.icymint.libra.sage.model.object.AbstractSql;
import me.icymint.libra.sage.model.object.SqlObjectType;

/**
 * SQL字段对象，存储关于SQL字段的信息。 其封装了一个{@link SqlType}类型和以字符串形式表示的默认值。
 * 
 * @author Daniel
 * @datetime 2013-1-9上午8:42:58
 * 
 */
public class SqlVar extends AbstractSql {

	public static Object valueOf(Object value) {
		if (value instanceof String) {
			return "'" + value + "'";
		} else
			return value;
	}

	private final SqlType st;

	private final String defaultvalue;

	public SqlVar(SqlType st, String defaultvalue, SqlInfo si, String name,
			boolean isMask) {
		super(si, null, name, isMask);
		this.st = st;
		this.defaultvalue = defaultvalue;
	}

	public String getDefaultValue() {
		return this.defaultvalue == null ? st.getDefaultValue()
				: this.defaultvalue;
	}

	@Override
	public String getId() {
		String d = "";
		if (defaultvalue != null)
			d += ",'" + defaultvalue + "'";
		return getName() + "(" + st.getIndex() + d + ")";
	}

	@Deprecated
	@Override
	public String getPrefix() {
		return "";
	}

	@Override
	protected SqlObjectType getSqlObjectType() {
		return SqlObjectType.Var;
	}

	public SqlType getType() {
		return st;
	}
}
