package me.icymint.libra.sage.model;

import java.sql.Types;

/**
 * 打包所有的JdbcType类型。
 * 
 * @see Types
 * @author Daniel
 * @datetime 2013-1-4上午11:09:09
 * 
 */
public enum SqlVarType {
	/**
	 * 表示数组。
	 */
	ARRAY(Types.ARRAY),
	/**
	 * 64位有符号整数。 -9223372036854775808 to 9223372036854775807
	 */
	BIGINT(Types.BIGINT),
	/**
	 * 254 bytes
	 */
	BINARY(Types.BINARY),
	/**
	 * 0, 1
	 */
	BIT(Types.BIT),
	/**
	 * 
	 */
	BLOB(Types.BLOB),
	/**
	 * true , false
	 */
	BOOLEAN(Types.BOOLEAN),
	/**
	 * 254 (8-bit characters)
	 */
	CHAR(Types.CHAR, true), CLOB(Types.CLOB),
	/**
	 * Java 1.4 and above. References a file outside of the database but that is
	 * managed by it. Maps to java.net.URL
	 */
	DATALINK(Types.DATALINK),
	/**
	 * year, month, day
	 */
	DATE(Types.DATE),
	/**
	 * 15 for precision (total number of digits) and for scale (number of digits
	 * after the decimal point)
	 */
	DECIMAL(Types.DECIMAL, true),
	/**
	 * Represents a distinct value, totally implementation dependent
	 */
	DISTINCT(Types.DISTINCT),
	/**
	 * 15 bits of mantissa (fractional part)
	 */
	DOUBLE(Types.DOUBLE),
	/**
	 * 
	 */
	FLOAT(Types.FLOAT), INTEGER(Types.INTEGER), JAVA_OBJECT(Types.JAVA_OBJECT),
	/**
	 * 
	 */
	LONGVARBINARY(Types.LONGVARBINARY),
	/**
	 * 
	 */
	LONGNVARCHAR(Types.LONGNVARCHAR),
	/**
	 * 
	 */
	LONGVARCHAR(Types.LONGVARCHAR),
	/**
	 * 
	 */
	NULL(Types.NULL),
	/**
	 * 
	 */
	NUMERIC(Types.NUMERIC),
	/**
	 * 
	 */
	OTHER(Types.OTHER),
	/**
			 * 
			 */
	REAL(Types.REAL),
	/**
			 * 
			 */
	REF(Types.REF),
	/**
			 * 
			 */
	SMALLINT(Types.SMALLINT),
	/**
			 * 
			 */
	STRUCT(Types.STRUCT),
	/**
			 * 
			 */
	TIME(Types.TIME),
	/**
			 * 
			 */
	TIMESTAMP(Types.TIMESTAMP),
	/**
			 * 
			 */
	TINYINT(Types.TINYINT),
	/**
			 * 
			 */
	VARBINARY(Types.VARBINARY, true),
	/**
			 * 
			 */
	VARCHAR(Types.VARCHAR, true);

	private int index;
	private boolean haslength;

	SqlVarType(int index) {
		this(index, false);
	}

	SqlVarType(int index, boolean haslength) {
		this.index = index;
		this.haslength = haslength;
	}

	public int getIndex() {
		return index;
	}

	public Class<?> getType() {
		return null;
	}

	public boolean hasLength() {
		return haslength;
	}
}
