package me.icymint.libra.sage.model.format;

import java.util.regex.Matcher;
import java.util.regex.Pattern;

/**
 * 格式化SQL语句，使之更美观。
 * 
 * @author Daniel
 * @datetime 2012-11-16下午2:25:18
 * 
 */
public class BeautyFormat implements FormatSql {
	/**
	 * 查找所有被分隔的代码段。
	 */
	private static Pattern p = Pattern.compile("(?<=(\n|^))([^\n]+)(?=(\n|$))");
	private static Pattern p2 = Pattern.compile("(.{1,70},)(.+)");
	private static String BREAK = "(;|BEGIN|THEN)";
	private static String BREAK2 = "(WHERE|(?<!DELETE )FROM|(?<!INSERT )INTO|JOIN|(VALUES|IN)\\(|ORDER|GROUP|AND)";
	private static String BREAK3 = "(DELETE|INSERT|CREATE|SELECT|UPDATE)";

	@Override
	public String format(String sql) throws SqlFormatException {
		sql = COMPACT
				.format(sql)
				.replaceAll("((?<=" + BREAK + ")\\s?|\\s?(?=" + BREAK2 + "))",
						"\n").replaceAll("\n+", "\n");
		int i = 0, j = 0;
		Matcher m = p.matcher(sql);
		String temp = new String(sql);
		while (m.find()) {
			String name = m.group();
			if (name.matches(".*END( IF|);")) {
				i = 0;
				j--;
			}
			temp = temp.replace(name, get(i + j) + get(m.group(2), i + j + 1));
			if (name.startsWith("IF"))
				j++;
			if (name.matches("(" + BREAK3 + ".*)"))
				i++;
			if (name.matches(".*\\);"))
				i = 0;
			else if (name.endsWith(";") && i > 0) {
				i--;
			}
		}
		return temp;
	}

	private String get(int i) {
		String pad = "";
		for (int j = 0; j < i; j++)
			pad += "	";
		return pad;
	}

	/**
	 * 子分段。
	 * 
	 * @param sql
	 * @param i
	 */
	private String get(String sql, int i) {
		if (sql.length() > 70) {
			Matcher m = p2.matcher(sql);
			if (m.find()) {
				return m.group(1) + "\n" + get(i) + get(m.group(2), i);
			}
		}
		return sql;
	}

}
