package me.icymint.libra.sage.model.object;

import me.icymint.libra.sage.model.SqlFunction;
import me.icymint.libra.sage.model.SqlInfo;
import me.icymint.libra.sage.model.SqlTable;
import me.icymint.libra.sage.model.SqlVar;
import me.icymint.libra.sage.model.operator.FunctionManager;
import me.icymint.libra.sage.model.operator.ManagerObjects;
import me.icymint.libra.sage.model.operator.SQLExistsException;
import me.icymint.libra.sage.model.operator.SQLNotExistsException;

public abstract class FunctionManagerObject extends TableManagerObject
		implements FunctionManager {

	private final ManagerObjects<SqlFunction> mo;

	protected FunctionManagerObject(SqlInfo si, String prefix, String name,
			boolean isMask, SqlVar[] sv, SqlTable[] st, SqlFunction... sf) {
		super(si, prefix, name, isMask, sv, st);
		mo = new ManagerObjects<SqlFunction>(sf, SqlFunction.class);
	}

	@Override
	public void addFunction(SqlFunction f) throws SQLExistsException {
		mo.add(f);
	}

	@Override
	public void delFunction(SqlFunction f) {
		mo.del(f);
	}

	@Override
	public SqlFunction getFunction(int ind) throws SQLNotExistsException {
		return mo.get(ind);
	}

	@Override
	public SqlFunction getFunction(String name) throws SQLNotExistsException {
		return mo.get(name);
	}

	@Override
	public int getFunctionIndex(String name) throws SQLNotExistsException {
		return mo.getIndexOf(name);
	}

	@Override
	public SqlFunction[] getFunctions() {
		return mo.getAll();
	}

	@Override
	public int getFunctionSize() {
		return mo.getSize();
	}
}
