package me.icymint.libra.sage.model.object;

import me.icymint.libra.sage.model.SqlFunction;
import me.icymint.libra.sage.model.SqlInfo;
import me.icymint.libra.sage.model.SqlProcedure;
import me.icymint.libra.sage.model.SqlTable;
import me.icymint.libra.sage.model.SqlVar;
import me.icymint.libra.sage.model.operator.ManagerObjects;
import me.icymint.libra.sage.model.operator.ProcedureManager;
import me.icymint.libra.sage.model.operator.SQLExistsException;
import me.icymint.libra.sage.model.operator.SQLNotExistsException;

public abstract class ProcedureManagerObject extends FunctionManagerObject
		implements ProcedureManager {

	private final ManagerObjects<SqlProcedure> mo;

	protected ProcedureManagerObject(SqlInfo si, String prefix, String name,
			boolean isMask, SqlVar[] sv, SqlTable[] st, SqlFunction[] sf,
			SqlProcedure... sp) {
		super(si, prefix, name, isMask, sv, st, sf);
		mo = new ManagerObjects<SqlProcedure>(sp, SqlProcedure.class);
	}

	@Override
	public void addProcedure(SqlProcedure p) throws SQLExistsException {
		mo.add(p);
	}

	@Override
	public void delProcedure(SqlProcedure p) {
		mo.del(p);
	}

	@Override
	public SqlProcedure getProcedure(int ind) throws SQLNotExistsException {
		return mo.get(ind);
	}

	@Override
	public SqlProcedure getProcedure(String name) throws SQLNotExistsException {
		return mo.get(name);
	}

	@Override
	public int getProcedureIndex(String name) throws SQLNotExistsException {
		return mo.getIndexOf(name);
	}

	@Override
	public SqlProcedure[] getProcedures() {
		return mo.getAll();
	}

	@Override
	public int getProcedureSize() {
		return mo.getSize();
	}

}
