package me.icymint.libra.sage.model.operator;

import me.icymint.libra.sage.model.SqlFunction;

public interface FunctionManager {

	/**
	 * 新增函数，添加到函数列表末尾。
	 * 
	 * @param f
	 * @throws SQLExistsException
	 */
	void addFunction(SqlFunction f) throws SQLExistsException;

	/**
	 * 删除函数。
	 * 
	 * @param f
	 */
	void delFunction(SqlFunction f);

	/**
	 * 获取序列为ind的函数.
	 * 
	 * @param ind
	 * @throws SQLNotExistsException
	 */
	SqlFunction getFunction(int ind) throws SQLNotExistsException;

	/**
	 * 获取名称为name的函数。
	 * 
	 * @param name
	 * @throws SQLNotExistsException
	 */
	SqlFunction getFunction(String name) throws SQLNotExistsException;

	/**
	 * 获取名称为name的函数所在的序列号。
	 * 
	 * @param name
	 */
	int getFunctionIndex(String name) throws SQLNotExistsException;

	/**
	 * 获取所有函数。
	 */
	SqlFunction[] getFunctions();

	/**
	 * 获取函数总数。
	 */
	int getFunctionSize();
}
