package me.icymint.libra.sage.model.operator;

import java.sql.SQLException;

/**
 * Sql对象管理，该接口用于实现Sql对象的创建和删除。 该接口的实现被要求同步到数据库中，即该接口的方法均指的是在数据库中的创建和删除。
 * 
 * @author Daniel
 * @datetime 2012-11-14上午9:33:45
 * 
 */
public interface SqlManager {
	/**
	 * 创建Sql对象，如果无法创建，抛出违例。
	 * 
	 * @throws SQLException
	 */
	void create() throws SQLException;

	void createIfNotExist();

	/**
	 * 删除Sql对象，如果无法删除，抛出违例。
	 * 
	 * @throws SQLException
	 */
	void delete() throws SQLException;

	/**
	 * alter接口暂时不实现，其用于更新Sql对象。
	 */
	// void alter() throws SQLException;
}
