package me.icymint.libra.sage.model.orm;

import java.util.LinkedHashMap;
import java.util.LinkedHashSet;
import java.util.Map;
import java.util.Set;

public class IdContainer<T extends IdMapping<V>, V> {

	private final V def;
	private final Set<T> set = new LinkedHashSet<T>();
	private final Map<V, T> map = new LinkedHashMap<V, T>();

	public IdContainer(V def) {
		this.def = def;
	}

	public T fetchById(V id) {
		return map.get(id);
	}

	public V getDefaultNullValue() {
		return def;
	}

	public void registerObject(T t, V old) {
		if (t == null)
			return;
		V n = t.fetchId();
		if (t.equal(n, old))
			return;
		if (t.equal(old, def)) {
			set.remove(t);
		} else {
			map.remove(old);
		}
		if (t.equal(n, def)) {
			set.add(t);
		} else {
			if (!map.containsKey(n))
				map.put(n, t);
		}
	}
}
