package me.icymint.libra.sage.model.xml;

import java.io.InputStream;
import java.io.OutputStream;

import me.icymint.libra.sage.model.SqlFactory;
import me.icymint.libra.sage.model.SqlInfo;

/**
 * sql解析器，其用于解析xml文件输入流。
 * 
 * @author Daniel
 * @datetime 2012-9-20上午11:49:36
 * 
 */
public interface SqlParser {
	SqlParser INSTANCE = new DefaultSqlParser();
	String ROOT = "database";
	String INFO = "info";
	String INFO_SQL = "sql";
	String TYPE = "type";
	String TABLE = "table";
	String VAR = "var";
	String FUNCTION = "function";
	String RETURN = "return";
	String PROCEDURE = "procedure";
	String INJECTOR = "injector";
	String NAME = "name";
	String ID = "id";
	String INJECTOR_METHOD = "method";
	String CLASS = "class";
	String NOTNULL = "notnull";
	String UNIQUE = "unique";
	String KEY = "key";
	String LENGTH = "length";
	String DEFAULT = "default";
	String MASK = "mask";
	String PREFIX = "prefix";
	String FOREIGN = "foreign";
	String AUTO_INCREMENT = "auto-increment";
	String CALL = "call";
	String MAPPINGS = "mappings";
	String MAPPING = "mapping";
	String PROPERTY_EDITOR = "property-editor";
	String PACK_UTILS = "pack-utils";
	String VALUE = "value";
	String INFO_SQL_ALL = "all";

	/**
	 * 根据提供的SqlInfo信息，解析xml配置流，并返回Sql工厂。
	 * 
	 * @param xml
	 * @param si
	 * @throws XmlParserException
	 */
	SqlFactory parserXml(InputStream xml, SqlInfo si) throws XmlParserException;

	/**
	 * 把Sql工厂的信息保存到xml文件中。
	 * 
	 * @param xml
	 * @param sf
	 * @throws XmlStoreException
	 */
	void storeXml(OutputStream xml, SqlFactory sf) throws XmlStoreException;

	/**
	 * 验证xml流是否有效。
	 * 
	 * @param xml
	 */
	boolean validateXml(InputStream xml);
}